'use strict';
goog.provide('Blockly.Blocks.Motor_Shield_7GP');

goog.require('Blockly.Blocks');

Blockly.Blocks.Motor_Shield_7GP.HUE3 = 140;

//PS2
Blockly.Blocks.PS2X_init={
	init: function() {
    this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
	this.appendDummyInput("")
	    .appendField(Blockly.QGPMsg.CONN_PS2);
	this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('www.7gp.cn 微信公众号：奇果派工坊');
  
  }
};

//
Blockly.Blocks.PS2X_Button={
	init: function() {
    this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
	var PSBUTTON =[
		["PSB_PAD_UP","PSB_PAD_UP"],
		["PSB_PAD_DOWN","PSB_PAD_DOWN"],
		["PSB_PAD_LEFT","PSB_PAD_LEFT"],		
		["PSB_PAD_RIGHT","PSB_PAD_RIGHT"],
		["PSB_TRIANGLE","PSB_TRIANGLE"],
		["PSB_CIRCLE","PSB_CIRCLE"],
		["PSB_CROSS","PSB_CROSS"],
		["PSB_SQUARE","PSB_SQUARE"],
		["PSB_L1","PSB_L1"],
		["PSB_L2","PSB_L2"],
		["PSB_L3","PSB_L3"],
		["PSB_R1","PSB_R1"],
		["PSB_R2","PSB_R2"],
		["PSB_R3","PSB_R3"],
		["PSB_SELECT","PSB_SELECT"],
		["PSB_START","PSB_START"]
	];
	this.appendDummyInput("")
	    .appendField(Blockly.QGPMsg.PS2_BTN)
	    .appendField(new Blockly.FieldDropdown(PSBUTTON), "psbt")
		.appendField(Blockly.QGPMsg.STATUS)
	    .appendField(new Blockly.FieldDropdown([["Pressed", "1"],["Released","0"]]), "btstate");
	this.setOutput(true, Boolean);
	var thisBlock = this;
        this.setTooltip('www.7gp.cn 微信公众号：奇果派工坊');
   
  }
};

Blockly.Blocks.PS2X_stk={
	init: function() {
    this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
	var PSSTK =[
		["PSS_RX","PSS_RX"],
		["PSS_RY","PSS_RY"],
		["PSS_LX","PSS_LX"],
		["PSS_LY","PSS_LY"],
	];
	this.appendDummyInput("")
	    .appendField(Blockly.QGPMsg.PS_STATICK)
		.appendField(new Blockly.FieldDropdown(PSSTK), "psstk");

	this.setOutput(true, Number);
	var thisBlock = this;
        this.setTooltip('www.7gp.cn 微信公众号：奇果派工坊');
   
  }
};

//
Blockly.Blocks.PS2X_vibrate={
	init: function() {
      this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
	this.appendDummyInput("")
	    .appendField(Blockly.QGPMsg.vibrate);
	this.setPreviousStatement(true);
      this.setNextStatement(true);
      this.setInputsInline(true);
   
  }
};

//Motor_init
Blockly.Blocks.Motor_init={
	init: function() {
    this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
	this.appendDummyInput("")
	    .appendField(Blockly.QGPMsg.Motor_init);
	this.setPreviousStatement(true);
    this.setNextStatement(true);
    this.setTooltip('启动驱动器的第一个步骤@奇果派');
  
  }
};


//DCMotorRun
Blockly.Blocks.DCMotorRun={
	init: function() {
	this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
    	var MOTOR =[
		["M1","1"],
		["M2","2"],
		["M3","3"],
		["M4","4"],
	];  
	var DIRECTION =[
		["FORWARD","FORWARD"],
		["BACKWARD","BACKWARD"],
	];
	var SPEED =[
		["100","100"],
		["150","150"],
		["200","200"],
		["250","250"],
	];
		
	this.appendDummyInput("")
		.appendField(Blockly.QGPMsg.RunMotor)
		.appendField(new Blockly.FieldDropdown(MOTOR), "motor")
		.appendField(Blockly.QGPMsg.Direction)
		.appendField(new Blockly.FieldDropdown(DIRECTION), "direction")
		.appendField(Blockly.QGPMsg.Speed);
		this.appendValueInput("speed", Number)
		.setCheck(Number);
		this.setInputsInline(true);
		// .appendField(new Blockly.FieldDropdown(SPEED), "speed");
	this.setPreviousStatement(true);
	this.setNextStatement(true);
	this.setTooltip('转动电机');
  
  }
};



//DCMotorStop
Blockly.Blocks.DCMotorStop={
	init: function() {
	this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
    	var MOTOR =[
		["M1","1"],
		["M2","2"],
		["M3","3"],
		["M4","4"],
	];  
		
	this.appendDummyInput("")
		.appendField(Blockly.QGPMsg.StopMotor)
		.appendField(new Blockly.FieldDropdown(MOTOR), "motor");
	this.setPreviousStatement(true);
	this.setNextStatement(true);
  
  }
};

//SERVO init
Blockly.Blocks.SERVO_init={
	init: function() {
	this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
    	var SERVO =[
				["0","0"],
				["1","1"],
				["2","2"],
				["3","3"],
				["4","4"],
				["5","5"],
				["6","6"],
				["7","7"],
	];  
	this.appendDummyInput("")
		.appendField(Blockly.QGPMsg.InitServo)
		.appendField(new Blockly.FieldDropdown(SERVO), "servo");
    this.appendValueInput("DEGREE", Number)
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_DEGREE_0_180);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);
    this.setTooltip('在setup函数中初始化舵机');
  
  }
};


//SERVO
Blockly.Blocks.SERVO={
	init: function() {
	this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
    	var SERVO =[
		["0","0"],
		["1","1"],
		["2","2"],
		["3","3"],
		["4","4"],
		["5","5"],
		["6","6"],
		["7","7"],
	];  
	this.appendDummyInput("")
		.appendField(Blockly.QGPMsg.Servo)
		.appendField(new Blockly.FieldDropdown(SERVO), "servo");
    this.appendValueInput("DEGREE", Number)
        .setCheck(Number)
        .setAlign(Blockly.ALIGN_RIGHT)
        .appendField(Blockly.MIXLY_DEGREE_0_180);
    this.setPreviousStatement(true, null);
    this.setNextStatement(true, null);

  
  }
};




Blockly.Blocks.ReadSERVO={
	init: function() {
    this.setColour(Blockly.Blocks.Motor_Shield_7GP.HUE3);
    
    	var SERVO =[
				["0","0"],
				["1","1"],
				["2","2"],
				["3","3"],
				["4","4"],
				["5","5"],
				["6","6"],
				["7","7"],
	];      
	this.appendDummyInput("")
	    .appendField(Blockly.QGPMsg.ReadServo)
		.appendField(new Blockly.FieldDropdown(SERVO), "servo");

	this.setOutput(true, Number);
	var thisBlock = this;
  }
};


// Blockly.Blocks.controls_mstimer2 = {
// 	init: function() {
// 	  this.setColour(Blockly.Blocks.loops.HUE);
// 	  this.appendValueInput('TIME')
// 		  .setCheck(Number)
// 		  .setAlign(Blockly.ALIGN_RIGHT)
// 		  .appendField('MsTimer2')
// 		  .appendField(Blockly.MIXLY_MSTIMER2_EVERY);
// 	  this.appendDummyInput()
// 		  .appendField('ms');
// 	  this.appendStatementInput('DO')
// 		  .appendField(Blockly.MIXLY_MSTIMER2_DO);
// 	  this.setPreviousStatement(true);
// 	  this.setNextStatement(true);
// 	}
//   };