function heredoc(fn) {
	return fn.toString().split('\n').slice(1, -1).join('\n') + '\n'
}

Blockly.Arduino.PS2X_init = function () {
	Blockly.Arduino.definitions_['adefine21_PS2X_init'] = 'PS2X ps2x;';

	Blockly.Arduino.setups_['setup01_PS2X_init'] = //'ps2x.config_gamepad(13,11,10,12, true, true);';
		heredoc(function () {/*
       
  int error = 0;
  do{
    error = ps2x.config_gamepad(13,11,10,12, true, true);
    if(error == 0){
      break;
    }else{
      delay(100);
    }
  }while(1); 
  for(size_t i = 0; i < 50; i++)
  {
        ps2x.read_gamepad(false, 0);
        delay(10);
  }
*/});
	return "ps2x.read_gamepad(false, 0);\ndelay(3);\n";
};


//readcardnum
Blockly.Arduino.PS2X_Button = function () {
	var bt = this.getFieldValue('psbt');
	var btstate = this.getFieldValue('btstate');
	if (btstate == "1") {
		var st = "ps2x.Button(" + bt + ")";
	} else {
		var st = "ps2x.ButtonReleased(" + bt + ")";
	}
	return [st];
};

Blockly.Arduino.PS2X_stk = function () {
	var stk = this.getFieldValue('psstk');
	var st = "ps2x.Analog(" + stk + ")";
	return [st];
};

Blockly.Arduino.PS2X_vibrate = function () {
	return "ps2x.read_gamepad(true, 200);\ndelay(300);\nps2x.read_gamepad(false, 0);\n";
};

Blockly.Arduino.Motor_init = function () {
	Blockly.Arduino.definitions_['adefine00_Wire'] = '#include <Wire.h>';
	Blockly.Arduino.definitions_['adefine01_PS2X'] = '#include <PS2X_lib.h>';
	Blockly.Arduino.definitions_['adefine02_PWMServoDriver'] = '#include <Adafruit_MS_PWMServoDriver.h>';
	Blockly.Arduino.definitions_['adefine03_MotorShield'] = '#include "QGPMaker_MotorShield.h"';
	Blockly.Arduino.definitions_['adefine20_Motor_init'] = 'QGPMaker_MotorShield AFMS = QGPMaker_MotorShield();  ';

	Blockly.Arduino.setups_['setup00_Motor_init_1'] = 'AFMS.begin(50); ';
	return '';
};


Blockly.Arduino.DCMotorRun = function () {
	var motor = this.getFieldValue('motor');
	var direction = this.getFieldValue('direction');
	var speed = Blockly.Arduino.valueToCode(this, 'speed', Blockly.Arduino.ORDER_ATOMIC);
	var vcode = "";
	var dcMotor = "DCMotor_" + motor;
	Blockly.Arduino.definitions_['adefine21_motorRun_' + motor] = 'QGPMaker_DCMotor *' + dcMotor + ' = AFMS.getMotor(' + motor + ');';
	vcode = dcMotor + "->setSpeed(" + speed + ");\n" + dcMotor + "->run(" + direction + ");\n";
	return vcode;
};

Blockly.Arduino.DCMotorStop = function () {
	var motor = this.getFieldValue('motor');
	var vcode = "";
	var dcMotor = "DCMotor_" + motor;
	Blockly.Arduino.definitions_['adefine21_motorRun_' + motor] = 'QGPMaker_DCMotor *' + dcMotor + ' = AFMS.getMotor(' + motor + ');';
	vcode = dcMotor + "->setSpeed(0);\n" + dcMotor + "->run(RELEASE);\n";
	return vcode;
};

Blockly.Arduino.SERVO_init = function () {
	var servo = this.getFieldValue('servo');
	var value_degree = Blockly.Arduino.valueToCode(this, 'DEGREE', Blockly.Arduino.ORDER_ATOMIC);
	var vcode = "";
	var XServo = "Servo" + servo;
	Blockly.Arduino.definitions_['adefine22_Servo_' + servo] = 'QGPMaker_Servo *' + XServo + ' = AFMS.getServo(' + servo + ');';
	vcode = XServo + "->writeServo(" + value_degree + ");";
	Blockly.Arduino.setups_['setup02_SERVO_init_' + servo] = vcode;
	return '';
};

Blockly.Arduino.SERVO = function () {
	var servo = this.getFieldValue('servo');
	var value_degree = Blockly.Arduino.valueToCode(this, 'DEGREE', Blockly.Arduino.ORDER_ATOMIC);
	var vcode = "";
	var XServo = "Servo" + servo;
	Blockly.Arduino.definitions_['adefine22_Servo_' + servo] = 'QGPMaker_Servo *' + XServo + ' = AFMS.getServo(' + servo + ');';
	vcode = XServo + "->writeServo(" + value_degree + ");";
	return vcode;
};


Blockly.Arduino.ReadSERVO = function () {
	var servo = this.getFieldValue('servo');
	var XServo = "Servo" + servo;
	Blockly.Arduino.definitions_['adefine22_Servo_' + servo] = 'QGPMaker_Servo *' + XServo + ' = AFMS.getServo(' + servo + ');';
	var vcode = XServo + "->readDegrees()";
	return [vcode];
};


// Blockly.Arduino.Scheduler = function () {
// 	Blockly.Arduino.definitions_['include_TaskScheduler'] = '#include <TaskScheduler.h>';
// 	Blockly.Arduino.definitions_['define_Scheduler_init'] = 'Scheduler runner;';
	

// 	var taskID = this.getFieldValue('taskID');
// 	var taskName = 'task'+taskID;
//     // var time = Blockly.Arduino.valueToCode(this, 'TIME', Blockly.Arduino.ORDER_ATOMIC);
//     var funcName = 'taskCallback'+taskID;
//     var branch = Blockly.Arduino.statementToCode(this, 'DO');
//     var code = 'void' + ' ' + funcName + '() {\n' + branch + '}\n';
// 	Blockly.Arduino.definitions_[funcName] = code;
// 	Blockly.Arduino.definitions_[taskName] = 'Task t2(3000, TASK_FOREVER, &'+funcName+');';
//     return 'runner.execute();\n';
// };